
// MFC_Cpp_ApiTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC_Cpp_ApiTest.h"
#include "MFC_Cpp_ApiTestDlg.h"
#include "afxdialogex.h"
//#include "pcmcat_api.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CMFCCppApiTestDlg dialog



CMFCCppApiTestDlg::CMFCCppApiTestDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MFC_CPP_APITEST_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCCppApiTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFCCppApiTestDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CMFCCppApiTestDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMFCCppApiTestDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMFCCppApiTestDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMFCCppApiTestDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CMFCCppApiTestDlg message handlers

BOOL CMFCCppApiTestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCCppApiTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCCppApiTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCCppApiTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void __stdcall CMFCCppApiTestDlg::static_pcmcat_api_callback(void *context, pcmcat_api_callback_data_t *pcmcat_api_callback_data)
{
	if (!pcmcat_api_callback_data)
		return;

	switch (pcmcat_api_callback_data->type)
	{
	case pcmcat_api_callback_type_message:
		if (pcmcat_api_callback_data->data.str)
			MessageBoxA(((CMFCCppApiTestDlg *)context)->GetSafeHwnd(), pcmcat_api_callback_data->data.str, "Callback Dialogue", MB_OK | MB_ICONWARNING);
	}
}

void CMFCCppApiTestDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	if (pcmcat_api_open(static_pcmcat_api_callback, this) == 0)
		MessageBoxA(this->GetSafeHwnd(), "PC-MCAT API opened connection correctly", "Connection Dialogue", MB_OK);
	else
		MessageBoxA(this->GetSafeHwnd(), "Error opening the PC-MCAT API connection", "Error", MB_OK | MB_ICONERROR);
}


void CMFCCppApiTestDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	pcmcat_api_close();
}


void CMFCCppApiTestDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	CString str_value;
	double value;

	((CEdit *)GetDlgItem(IDC_EDIT1))->GetWindowTextW(str_value);
	value = _wtof(str_value);

	if (pcmcat_api_set_vr(0, 1, &value) != 0)
		MessageBoxW(L"Error setting VR(0) to " + str_value, L"Error", MB_OK | MB_ICONERROR);
}


void CMFCCppApiTestDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	CString str_value;
	double value;

	if (pcmcat_api_get_vr(0, 1, &value) != 0)
		MessageBoxW(L"Error Getting value of VR(0)", L"Error", MB_OK | MB_ICONERROR);
	else
	{
		str_value.Format(L"%.4f", value);
		((CEdit *)GetDlgItem(IDC_EDIT2))->SetWindowTextW(str_value);
	}
}
