﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TrioMotion.PCMCAT;

namespace WindowsForms_Cs_ApiTest
{
    public partial class Form1 : Form
    {
        PCMCAT_API.Callback CallbackDelegate;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            CallbackDelegate = CallbackFunction;
            if (PCMCAT_API.Open(CallbackDelegate, IntPtr.Zero) == 0)
            {
                MessageBox.Show("PC-MCAT API .Net assembly opened connection correctly");
            }
            else
            {
                MessageBox.Show("Error opening the PC-MCAT API .Net assembly connection");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            PCMCAT_API.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (PCMCAT_API.SetVR(0, Double.Parse(textBox1.Text)) != 0)
            {
                MessageBox.Show("Error setting VR(0) to " + textBox1.Text);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            double vr0;
            if (PCMCAT_API.GetVR(0, out vr0) != 0)
            {
                MessageBox.Show("Error getting VR(0)");
            }
            else
            {
                textBox2.Text = vr0.ToString();
            }
        }

        void CallbackFunction(IntPtr Context, ref PCMCAT_API.CallbackData Data)
        {
            switch (Data.Type)
            {
                case PCMCAT_API.CallbackType.Message:
                    MessageBox.Show(Marshal.PtrToStringAnsi(Data.Data.Str));
                    break;
            }
        }
    }
}
